"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cp = tslib_1.__importStar(require("child_process"));
const kleur_1 = tslib_1.__importDefault(require("kleur"));
exports.spawn = cp.spawn;
exports.run = async (cmd, args, options) => {
    process.stdout.write(`\n${kleur_1.default.cyan(`> ${cmd} ${args
        .map(arg => (arg.includes(' ') ? `"${arg}"` : arg))
        .join(' ')}`)}\n`);
    await exports.wait(exports.spawn(cmd, args, options));
};
exports.wait = async (p) => {
    return new Promise((resolve, reject) => {
        p.on('error', reject);
        p.on('close', (code, signal) => {
            if (code === 0) {
                resolve();
            }
            else {
                reject(new Error(`bad subprocess exit (code=${code}, signal=${signal})`));
            }
        });
    });
};
